;; DensetsuMini.exe から呼ばれる
;; 2023/07/23
(defun densetsuMini( blkFullName scale rotdeg pt / vctr attreq
                    blkName bname elast elast2 org_error ortho )
  (defun my_error(msg)
    (princ (strcat "\n" msg))
    (setvar "CMDECHO" 1)
    (setvar "ORTHOMODE" ortho)
    (setvar "ATTREQ" attreq)
    (setq *error* org_error)
    (princ)
  )
  (setq org_error *error*)
  (setq *error* my_error)
  
  (setq blkName  (vl-filename-base blkFullName))
  ;;(princ "\nblkName=")(princ blkName)
  (if (tblobjname "block" blkName)
    (setq bname blkName)
    (setq bname blkFullName)
  ) 
  (setq attreq (getvar "ATTREQ") ortho (getvar "ORTHOMODE"))
  (setvar "ATTREQ" 0)
  (setvar "CMDECHO" 0)
  (if (not pt)
    (progn
      (Command "_.-INSERT" bname "S" scale "PS" scale "R" rotdeg pause)
      (setvar "ATTREQ" attreq)
    )
    (progn
      (if (> ortho 0) (setvar "ORTHOMODE" 0))
      (setq elast (entlast) vctr (getvar "VIEWCTR"))
      (command "_.-INSERT" bname "S" scale "PS" scale "R" rotdeg "_none" vctr)
      (setvar "ATTREQ" attreq)
      (if (not (equal elast (setq elast2 (entlast))))
        (progn
          (command "_.COPYBASE" "_none" (mapcar '+ vctr pt) elast2 "")
          (command "_.ERASE" elast2 "")
          (command "_.PASTECLIP")
          (while (wcmatch (getvar "CMDNAMES") "*PASTECLIP")
            (command pause)
          )
        )
      )
      (if (> ortho 0) (setvar "ORTHOMODE" ortho))
    )
  )
  (setvar "CMDECHO" 1)
  (setvar "ORTHOMODE" ortho)
  (setvar "ATTREQ" attreq)
  (setq *error* org_error)
  (princ)
)